<?php
/***************************************************************************\
 *  Plugin Statistiques pour les brèves                          	   	 *
 *                                                                         *
 *  Copyright (c) 2007-2008                                                *
 *  Elrik - Peetdu														 *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
\***************************************************************************/

include_spip ("inc/utils");
include_spip ("base/abstract_sql");

$p = explode(basename(_DIR_PLUGINS).
			 "/", str_replace('\\', '/', realpath(dirname(__FILE__))));
define('_DIR_PLUGIN_STATS_BREVES',(_DIR_PLUGINS.end($p)));

function stats_breves_ajouterBoutons($boutons_admin) {
	// si on est admin
	if ($GLOBALS['connect_statut'] == "0minirezo" AND
		$GLOBALS["connect_toutes_rubriques"]) {
		// on voit le bouton dans la barre "statistiques"
		$boutons_admin['statistiques_visites']->sousmenu["stats_breves_tableau"] =\
			new Bouton(
			 _DIR_PLUGIN_STATS_BREVES."img_pack/breves.gif",  // icone
		     _T('stbrv:statistiques_breves')	// titre  
		 );
	}
	return $boutons_admin;
}

/*
 * traitement d'un fichier session de stats
 */
function SBRV_compte_visites($fichier, &$breves, &$visites_b) {
	spip_log("BREVES : traite la session $fichier");
	$content = array();
	if (lire_fichier($fichier, $content))
		$content = @unserialize($content);
	if (!is_array($content)) return;
	
	foreach ($content as $source => $num) {
		list($log_type, $log_id_num, $log_referer)
			= preg_split(",\t,", $source, 3);
		if ($log_type == 'breve'
			AND $id_breve = intval($log_id_num)) {
			$breves[] = $id_breve;
			$visites_b[$id_breve] ++;
		}
	}
}

function calcul_visite_breve($t) {
	$visites_b = array(); // tableau des visites des breves
	$breves = array(); // liste des breves
	$sessions = preg_files(sous_repertoire(_DIR_TMP, 'visites'));
	$compteur = 100;
	$delai = 30*60; // 30 minutes
	//$delai = 10;
	$stop_day = false;
	for ($day=2; $day>=0 AND !$stop_day; $day--) {
		$date_init = time() - $delai - ($day * 24 * 60 * 60);
		foreach ($sessions as $item) {
			if (@filemtime($item) < $date_init) {
				$stop_day = true;
				SBRV_compte_visites($item, $breves, $visites_b);
				//@unlink($item);
				/*
				 * On ne detruit pas le fichier car il est utilise par 
				 * d'autres compteurs comme visites du site ou visites breves.
				 */
				if (--$compteur <= 0)
					break;
				
			}
		}
	}

	if (!$breves) return;
	// enregistrer les visites dans les deux tables
	$ar = array();	// tableau num -> liste des breves ayant num visites
	$tous = array(); // liste des breves ayant des visites
	foreach($visites_b as $id_breve => $num) {
		$ar[$num][] = $id_breve;
		$tous[] = $id_breve;
	}
	$tous = calcul_mysql_in('id_breve', join(',', $tous));
	$sum = '';
	foreach ($ar as $num => $liste)
		$sum .= ' + '.$num.'*'
		. calcul_mysql_in('id_breve', join(',',$liste));

	// handle total stats 
	$query = "UPDATE spip_breves SET maj = maj, ".
		"visites = visites $sum WHERE $tous";
	spip_query($query);

	// handle stats per breve
	$date = date("Y-m-d", $date_init);
	$query = "INSERT IGNORE INTO spip_visites_breves (date, id_breve)".
		" VALUES ('$date',". join("), ('$date',", $breves) . ")";
	spip_query($query);
	$query = "UPDATE spip_visites_breves SET visites = visites $sum ".
		"WHERE date='$date' AND $tous";
	spip_query($query);
	
	if ($compteur==0) {
		spip_log("BREVES : il reste des visites a traiter...");
		return -$t;
	}
}

//utiliser le cron pour envoyer les messages en attente
function stats_breves_taches_generales_cron($taches_generales){
	/*
	 * breve_stat_cron doit être appele souvent pour etre sur
	 * de passe avant visites_cron (300 sec) car visites_cron
	 * detruit les fichiers de sessions toutes les 5 minutes
	 * CECI EST UN BUG - comment le resoudre sans intrusion dans SPIP ?
	 */
	$taches_generales['stats_breves_cron'] = 10 ;
	return $taches_generales;
}



function cron_stats_breves_cron($t) {
	spip_log("BREVES : lancement tache cron : ".
			 $GLOBALS['meta']['activer_statistiques']);
	if ($GLOBALS['meta']['activer_statistiques'] == 'oui' and
		$GLOBALS['meta']['activer_breves'] == 'oui') {
		$encore = calcul_visite_breve($t);
		// Si ce n'est pas fini on redonne la meme date au fichier .lock
		// pour etre prioritaire lors du cron suivant
		if ($encore)
			return (0 - $t);		
	}
	return 1;
}

?>
